//Key polling experiment:
// Observation:When you press the key, led will be turn on one by one in right direction
// Objection: understaning the difference between polling and interrupt
// Author: Gang Chen @ Technical University Munich
// cheng@in.tum.de
#include <avr/io.h>
#include <util/delay.h>
#include <stdint.h>

int main(void)
{
unsigned char key_cur,key_pre;
//config CPIO port
//PORT B for KEY: INPUT PORT
//PORT D for LED: OUTPUT PORT
//Config DDRx register: 1-ouptput, 0-input
DDRB=0x0f;
DDRD=0x00;
PORTB=0x01;  //turn on the led on the left side as initial state
PORTD=0xff;  //configurate as pull-up input port
//waiting for key pressed
while(1)
{
	key_pre=key_cur;    //Please think about: why we should have two variable here? You can try what happen if we use one variable.
	key_cur=PIND&0x1;   //read the key state
	_delay_ms(20);
	if(key_cur==0&&key_pre==1) 
	{
		if(PORTB==0x8)
			PORTB=0x01;
		else
			PORTB=PORTB<<1;
	}
}
}
